/*******************************************************************************
  Snes9x - Portable Super Nintendo Entertainment System (TM) emulator.
 
  (c) Copyright 1996 - 2003 Gary Henderson (gary.henderson@ntlworld.com) and
                            Jerremy Koot (jkoot@snes9x.com)

  (c) Copyright 2002 - 2003 Matthew Kendora and
                            Brad Jorsch (anomie@users.sourceforge.net)
 

                      
  C4 x86 assembler and some C emulation code
  (c) Copyright 2000 - 2003 zsKnight (zsknight@zsnes.com),
                            _Demo_ (_demo_@zsnes.com), and
                            Nach (n-a-c-h@users.sourceforge.net)
                                          
  C4 C++ code
  (c) Copyright 2003 Brad Jorsch

  DSP-1 emulator code
  (c) Copyright 1998 - 2003 Ivar (ivar@snes9x.com), _Demo_, Gary Henderson,
                            John Weidman (jweidman@slip.net),
                            neviksti (neviksti@hotmail.com), and
                            Kris Bleakley (stinkfish@bigpond.com)
 
  DSP-2 emulator code
  (c) Copyright 2003 Kris Bleakley, John Weidman, neviksti, Matthew Kendora, and
                     Lord Nightmare (lord_nightmare@users.sourceforge.net

  OBC1 emulator code
  (c) Copyright 2001 - 2003 zsKnight, pagefault (pagefault@zsnes.com)
  Ported from x86 assembler to C by sanmaiwashi

  SPC7110 and RTC C++ emulator code
  (c) Copyright 2002 Matthew Kendora with research by
                     zsKnight, John Weidman, and Dark Force

  S-RTC C emulator code
  (c) Copyright 2001 John Weidman
  
  Super FX x86 assembler emulator code 
  (c) Copyright 1998 - 2003 zsKnight, _Demo_, and pagefault 

  Super FX C emulator code 
  (c) Copyright 1997 - 1999 Ivar and Gary Henderson.



 
  Specific ports contains the works of other authors. See headers in
  individual files.
 
  Snes9x homepage: http://www.snes9x.com
 
  Permission to use, copy, modify and distribute Snes9x in both binary and
  source form, for non-commercial purposes, is hereby granted without fee,
  providing that this license information and copyright notice appear with
  all copies and any derived work.
 
  This software is provided 'as-is', without any express or implied
  warranty. In no event shall the authors be held liable for any damages
  arising from the use of this software.
 
  Snes9x is freeware for PERSONAL USE only. Commercial users should
  seek permission of the copyright holders first. Commercial use includes
  charging money for Snes9x or software derived from Snes9x.
 
  The copyright holders request that bug fixes and improvements to the code
  should be forwarded to them so everyone can benefit from the modifications
  in future versions.
 
  Super NES and Super Nintendo Entertainment System are trademarks of
  Nintendo Co., Limited and its subsidiary companies.
*******************************************************************************/

/*******************************************************************************
  Snes9x custom (Snes9x for Mac OS) by zones
  
  This build was started from John Stiles' port.
*******************************************************************************/

#include "memmap.h"
#include "gfx.h"
#include "apu.h"
#include "cheats.h"
#include "display.h"
#include "ppu.h"
#include "soundux.h"

#include <QuickTime/QuickTime.h>
#include <pthread.h>

#include "mac-prefix.h"
#include "mac-appleevent.h"
#include "mac-audio.h"
#include "mac-cheat.h"
#include "mac-cheatfinder.h"
#include "mac-dialog.h"
#include "mac-file.h"
#include "mac-gworld.h"
#include "mac-joypad.h"
#include "mac-keyboard.h"
#include "mac-musicbox.h"
#include "mac-prefs.h"
#include "mac-render.h"
#include "mac-snes9x.h"
#include "mac-stringtools.h"
#include "mac-os.h"

#define	kRecentMenu_MAX		20
#define KeyIsPressed(km, k)	(1 & (((unsigned char *) km) [(k) >> 3] >> ((k) & 7)))

extern int			spc_is_dumping;

volatile bool8		running             = false;

uint32				controlPad[5];

uint8				romDetect           = kAutoROMType,
					interleaveDetect    = kAutoInterleave,
					videoDetect         = kAutoVideo,
					headerDetect        = kAutoHeader;
				
WindowRef			gWindow             = nil;
Rect				gWindowRect;
int					glScreenW,
					glScreenH;
Point				windowPos[kWindowCount];

int64				lastFrame           = 0;
long				lastDrawingMethod   = 0;

Boolean				gFastForward        = false;

unsigned long		spcFileCount        = 0,
					pngFileCount        = 0;				
				
SInt32				systemVersion;

bool8				finished            = false,
					cartOpen            = false,
					autofire            = false,
					hidExist            = true,
					folderWarning       = false,
					lockedROMMedia      = false,
					directDisplay       = false;

bool8				fullscreen          = true,
					autoRes             = false,
					doubleSize          = true,
					tvMode              = false,
					smoothMode          = false,
					eagleMode           = false,
					saiMode             = false,
					supsaiMode          = false,
					glstretch           = true,
					glproportional      = true,
					gl32bit             = true,
					vsync               = true,
					drawoverscan        = false,
					multiprocessor      = false;
long				drawingMethod       = kDrawingDirect;

float				macSoundPitch       = 1.0,
					macSoundPitchMaster = 1.0;
SInt32				macSoundVolume      = 80;
int					macSoundInterval  	= 10;
uint16				aueffect            = 0;

uint8				saveInROMFolder     = 0;	// 0 : SNES9X  1 : ROM  2 : Application Support
int					mac7110Load         = 1,
					mac7110Megs         = 5,
					macSDD1Pack         = 1;

bool8				startopendlog       = true,
					showtimeinfrz       = true,
					enabletoggle        = true,
					allowevent          = true,
					savewindowpos       = false;
int					musicboxmode        = kMBXSoundEmulation;

bool8				scopecursor         = true,
					applycheat          = false;
int					padSetting          = 1,
					deviceSetting       = 1;	
AutoFireState		autofireRec[5];

CGDirectDisplayID   gMainDisplayID;

static void Initialize(void);
static void Deinitialize(void);
static void InitAutoFire(void);
static void InitRecentItems(void);
static void DeinitRecentItems(void);
static void ClearRecentItems(void);
static void InitRecentMenu(void);
static void DeinitRecentMenu(void);
static void PrepareMenus(void);
static void ChangeInputDevice(void);
static void ProcessInput(void);
static void PostQueueToSubEventLoop(void);
static void RestoreGWorldPixMap(GWorldPtr, Ptr);
static void UpdateActiveFrame(int, GWorldPtr, Ptr);
static void * MacSNES9XThread(void *);
static Ptr SaveGWorldPixMap(GWorldPtr);
static OSStatus HandleMenuChoice(long, Boolean *);
static inline void GetGameScreenRect(void);
static pascal OSStatus MainEventHandler(EventHandlerCallRef, EventRef, void *);
static pascal OSStatus SubEventHandler(EventHandlerCallRef, EventRef, void *);
static pascal OSStatus GameWindowEventHandler(EventHandlerCallRef, EventRef, void *);

typedef struct
{
	int	globalLeft;
	int	globalTop;
	int	width;
	int	height;
}	GameViewInfo;
	
static pthread_t		s9xthread;
static volatile bool8	s9xthreadrunning = false;

static MenuRef			recentMenu;
static CFStringRef		recentItem[kRecentMenu_MAX + 1];

static EventHandlerUPP	gameWindowUPP;
static EventHandlerRef	gameWindowEventRef;

static int				toggleff         = 0,
						togglescopeturbo = 0;
static Boolean			gScopeTurbo      = false;

static int				frameCount       = 0;

static bool8			mouseActive      = false;

static Boolean			frzselecting     = false;

static GameViewInfo		scopeViewInfo;

enum
{
	kmF1Key  = 0x7A,
	kmF2Key  = 0x78,
	kmF3Key	 = 0x63,
	kmF4Key	 = 0x76,
	kmF5Key	 = 0x60,
	kmEscKey = 0x35,
	kmCmdKey = 0x37,
	kmFKey   = 0x03,
	kmDKey   = 0x02,
	km1Key   = 0x12,
	km2Key   = 0x13,
	km3Key   = 0x14,
	km4Key   = 0x15,
	km5Key   = 0x17,
	km6Key   = 0x16,
	km7Key   = 0x1A,
	km8Key   = 0x1C,
	km9Key   = 0x19,
	kmAKey   = 0x00,
	kmBKey   = 0x0B,
	kmCKey   = 0x08,
	kmCtrKey = 0x3B
};

enum
{
	mApple          = 128,
	iAbout          = 1,
	
	mFile           = 129,
	iOpen           = 1,
	iOpenRecent     = 2,
	iRomInfo        = 4,
	
	mControl        = 134,
	iKeyboardLayout = 1,
	iISpLayout      = 2,
	iAutoFire       = 4,
	iISpPreset      = 6,
	
	mEdit           = 130,

	mEmulation      = 131,
	iResume         = 1,
	iSoftReset      = 3,
	iReset          = 4,
	iSwapPad        = 6,
	iScopeCursor    = 7,
	iDevice         = 9,
	
	mCheat          = 132,
	iApplyCheats    = 1,
	iGameGenie      = 3,
	iCheatFinder    = 4,

	mOption         = 133,
	iFreeze         = 1,
	iDefrost        = 2,
	iFreezeTo       = 4,
	iDefrostFrom    = 5,
	iSaveSPC        = 7,
	iSaveSRAM       = 8,
	iMusicBox       = 10,
	
	mPresets        = 201,
	
	mDevice         = 202,
	iPad            = 1,
	iMouse			= 2,
	iMouse2         = 3,
	iSuperScope     = 4,
	iMultiPlayer5   = 5,
	iJustifier1     = 6,
	iJustifier2     = 7,
	
	mRecentItem     = 203
};

int main(int argc, char **argv)
{
 	#pragma unused (argc, argv)

	OSStatus		err;
	EventHandlerRef	eref;
	EventHandlerUPP	appEventHandler;
	EventTypeSpec	events[] = { { kEventClassCommand, kEventCommandProcess } };
	
	appEventHandler = NewEventHandlerUPP(MainEventHandler);
 	err = InstallApplicationEventHandler(appEventHandler, 1, events, nil, &eref);
	
	Initialize();
   	
	while (!finished)
	{
		if (cartOpen && running)
		{			
			#ifdef DEBUGGER
				CPU.Flags |= DEBUG_MODE_FLAG;
				S9xDoDebug();
			#endif

			if (!allowevent || fullscreen || (drawingMethod == kDrawingDirect))
			{
				S9xInitDisplay(nil, nil);
				ClearGFXScreen();
				
				MacStartSound();
								
				while (running)
				{
					ProcessInput();
					S9xMainLoop();
				}
				
				MacStopSound();
				
				S9xDeinitDisplay();
			}
			else
			{
				CFStringRef	ref;
				MenuRef		menu;
				bool8		oldmouseActive;
				
				oldmouseActive = mouseActive;
				mouseActive = true;
				
				err = RemoveEventHandler(eref);
				DisposeEventHandlerUPP(appEventHandler);
				
				appEventHandler = NewEventHandlerUPP(SubEventHandler);
				err = InstallApplicationEventHandler(appEventHandler, 1, events, nil, &eref);
				
				S9xInitDisplay(nil, nil);
				ClearGFXScreen();

				menu = GetMenuHandle(mEmulation);
				
				ref = CFCopyLocalizedString(CFSTR("PauseMenu"), "pause");
				err = SetMenuItemTextWithCFString(menu, iResume, ref);
				CFRelease(ref);
				
				EnableMenuItem (menu, 0);
				EnableMenuItem (menu, iResume);
				DisableMenuItem(menu, iSoftReset);
				DisableMenuItem(menu, iReset);
				DisableMenuItem(menu, iSwapPad);
				DisableMenuItem(menu, iScopeCursor);
				DisableMenuItem(menu, iDevice);

				pthread_create(&s9xthread, nil, MacSNES9XThread, nil);
				
				RunApplicationEventLoop();
				
				pthread_join(s9xthread, nil);
				
				EnableMenuItem(menu, iSoftReset);
				EnableMenuItem(menu, iReset);
				EnableMenuItem(menu, iSwapPad);
				EnableMenuItem(menu, iScopeCursor);
				EnableMenuItem(menu, iDevice);
				
				ref = CFCopyLocalizedString(CFSTR("RunMenu"), "run");
				err = SetMenuItemTextWithCFString(menu, iResume, ref);
				CFRelease(ref);
				
				S9xDeinitDisplay();

				err = RemoveEventHandler(eref);
				DisposeEventHandlerUPP(appEventHandler);
				
				appEventHandler = NewEventHandlerUPP(MainEventHandler);
				err = InstallApplicationEventHandler(appEventHandler, 1, events, nil, &eref);
				
				mouseActive = oldmouseActive;
			}
		}

		if (!finished)
		{
			EnableMenus();
			RunApplicationEventLoop();
		}
	}
	
	Deinitialize();
	
	err = RemoveEventHandler(eref);
 	DisposeEventHandlerUPP(appEventHandler);

	return 0;
}

static void * MacSNES9XThread(void *p)
{
	#pragma unused (p)
	
	s9xthreadrunning = true;
	
	MacStartSound();
		
	while (running)
	{
		ProcessInput();
		S9xMainLoop();
	}	

	MacStopSound();

	s9xthreadrunning = false;
	
	return nil;
}

static pascal OSStatus MainEventHandler(EventHandlerCallRef inHandlerCallRef, EventRef inEvent, void *inUserData)
{
    #pragma unused (inHandlerCallRef, inUserData)
    
    OSStatus	err, result = eventNotHandledErr;
	Boolean		done = false;

	if (frzselecting)
		return result;

	switch (GetEventClass(inEvent))
	{
		case kEventClassCommand:
			switch (GetEventKind(inEvent))
			{
				case kEventCommandProcess:
					HICommand	cmd;

					err = GetEventParameter(inEvent, kEventParamDirectObject, typeHICommand, nil, sizeof(HICommand), nil, &cmd);
					if (err == noErr)
					{
						UInt32	modifierkey;
						
						err = GetEventParameter(inEvent, kEventParamKeyModifiers, typeUInt32, nil, sizeof(UInt32), nil, &modifierkey);
						if (err == noErr)
						{
							if ((cmd.commandID == 'pref') && (modifierkey & optionKey))
								cmd.commandID = 'Hidn';
							
							result = HandleMenuChoice(cmd.commandID, &done);
						
							if (done)
								QuitApplicationEventLoop();
						}
					}
			}
	}
	
	return result;
}

static pascal OSStatus SubEventHandler(EventHandlerCallRef inHandlerCallRef, EventRef inEvent, void *inUserData)
{
    #pragma unused (inHandlerCallRef, inUserData)
    
    OSStatus	err, result = eventNotHandledErr;
	
	if (frzselecting)
		return result;

	switch (GetEventClass(inEvent))
	{
		case kEventClassCommand:
			switch (GetEventKind(inEvent))
			{
				case kEventCommandProcess:
					HICommand	cmd;

					err = GetEventParameter(inEvent, kEventParamDirectObject, typeHICommand, nil, sizeof(HICommand), nil, &cmd);
					if (err == noErr)
					{
						switch (cmd.commandID)
						{
							case 'Erun':	// Pause
							case 'SubQ':	// Queue from emulation thread
								running = false;
								while (s9xthreadrunning)
									sleep(0);
								QuitApplicationEventLoop();
								result = noErr;
						}
					}
			}
	}
	
	return result;
}

static void PostQueueToSubEventLoop(void)
{
	OSStatus	err;
	EventRef	event;
	
	err = CreateEvent(kCFAllocatorDefault, kEventClassCommand, kEventCommandProcess, 0, kEventAttributeUserEvent, &event);
	if (err == noErr)
	{
		HICommand	cmd;
		
		cmd.commandID          = 'SubQ';
		cmd.attributes         = kEventAttributeUserEvent;
		cmd.menu.menuRef       = nil;
		cmd.menu.menuItemIndex = 0;
		
		err = SetEventParameter(event, kEventParamDirectObject, typeHICommand, sizeof(HICommand), &cmd);
		if (err == noErr)
			err = PostEventToQueue(GetMainEventQueue(), event, kEventPriorityStandard);
			
		ReleaseEvent(event);
	}
}

void InitGameWindow(void)
{
	OSStatus		err;
	CFStringRef		ref;
	Rect			rct = { 0, 0, kMacWindowHeight, 512 };
	char			drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT];
	EventTypeSpec	windowEvents[] = { { kEventClassMouse,  kEventMouseUp } };
	
	if (gWindow)
		return;
	
	err = CreateNewWindow(kDocumentWindowClass, kWindowCollapseBoxAttribute | kWindowStandardHandlerAttribute, &rct, &gWindow);

	gameWindowUPP = NewEventHandlerUPP(GameWindowEventHandler);
	err = InstallWindowEventHandler(gWindow, gameWindowUPP, 1, windowEvents, (void *) gWindow, &gameWindowEventRef);
	
	_splitpath(Memory.ROMFilename, drive, dir, fname, ext);
	ref = CFStringCreateWithCString(kCFAllocatorDefault, fname, MAC_PATH_ENCODING);
	if (ref)
	{
		SetWindowTitleWithCFString(gWindow, ref);
		CFRelease(ref);
	}
	
	//err = SetWindowProxyCreatorAndType(gWindow, '~9X~', 'APPL', kOnSystemDisk);
	
	if (savewindowpos)
		MoveWindow(gWindow, windowPos[kWindowScreen].h, windowPos[kWindowScreen].v, true);
	else
		MoveWindow(gWindow, (CGDisplayPixelsWide(gMainDisplayID) - 512) >> 1, (CGDisplayPixelsHigh(gMainDisplayID) - kMacWindowHeight) >> 1, true);

	ActivateWindow(gWindow, true);
	ShowWindow(gWindow);
}

void DeinitGameWindow(void)
{
	OSStatus	err;
	
	if (!gWindow)
		return;
		
	SaveWindowPosition(gWindow, kWindowScreen);
	
	err = RemoveEventHandler(gameWindowEventRef);
	DisposeEventHandlerUPP(gameWindowUPP);
	
	DisposeWindow(gWindow);
	gWindow = nil;
}

static pascal OSStatus GameWindowEventHandler(EventHandlerCallRef inHandlerCallRef, EventRef inEvent, void *inUserData)
{
    #pragma unused (inHandlerCallRef)

    OSStatus	err, result = eventNotHandledErr;
	WindowRef	tWindowRef = (WindowRef) inUserData;
	
	if (frzselecting)
		return result;
	
	switch (GetEventClass(inEvent))
	{
		case kEventClassMouse:
			switch (GetEventKind(inEvent))
			{
				case kEventMouseUp:
					Point	pt;

					err = GetEventParameter(inEvent, kEventParamMouseLocation, typeQDPoint, nil, sizeof(Point), nil, &pt);
					if (err == noErr)
					{
						Rect	rct;
						
						GlobalToLocal(&pt);
						GetWindowBounds(tWindowRef, kWindowContentRgn, &rct);
						if (PtInRect(pt, &rct))
						{				
							if (running)
							{
								if ((Settings.ControllerOption == SNES_JOYPAD) || (Settings.ControllerOption == SNES_MULTIPLAYER5))
								{
									running = false;
									while (s9xthreadrunning)
										sleep(0);
									QuitApplicationEventLoop();
									result = noErr;
								}
							}
							else
							{				
								UInt32	count;
								
								err = GetEventParameter(inEvent, kEventParamClickCount, typeUInt32, nil, sizeof(UInt32), nil, &count);
								if ((err == noErr) && (count == 2))
								{
									SNES9X_Go();
									QuitApplicationEventLoop();
									result = noErr;
								}
							}
						}
					}
			}
	}
	
	return result;
}

static void InitRecentItems(void)
{
	CFStringRef	keyRef, pathRef;
	int			count, i;
	char		key[32];
	
	count = 0;
	
	for (i = 0; i <= kRecentMenu_MAX; i++)
		recentItem[i] = nil;
	
	for (i = 0; i <  kRecentMenu_MAX; i++)
	{
		sprintf(key, "RecentItem_%02d", i);
		keyRef = CFStringCreateWithCString(kCFAllocatorDefault, key, CFStringGetSystemEncoding());
		if (keyRef)
		{
			pathRef = (CFStringRef) CFPreferencesCopyAppValue(keyRef, kCFPreferencesCurrentApplication);
			if (pathRef)
			{
				recentItem[count] = pathRef;
				count++;
			}
			
			CFRelease(keyRef);
		}
	}
}

static void DeinitRecentItems(void)
{
	CFStringRef	keyRef;
	int			i;
	char		key[32];

	for (i = 0; i < kRecentMenu_MAX; i++)
	{
		sprintf(key, "RecentItem_%02d", i);
		keyRef = CFStringCreateWithCString(kCFAllocatorDefault, key, CFStringGetSystemEncoding());
		if (keyRef)
		{
			if (recentItem[i])
			{
				CFPreferencesSetAppValue(keyRef, recentItem[i], kCFPreferencesCurrentApplication);
				CFRelease(recentItem[i]);
				recentItem[i] = nil;
			}
			else
				CFPreferencesSetAppValue(keyRef, nil, kCFPreferencesCurrentApplication);
			
			CFRelease(keyRef);
		}
	}
	
	CFPreferencesAppSynchronize(kCFPreferencesCurrentApplication);
}

static void ClearRecentItems(void)
{
	for (int i = 0; i < kRecentMenu_MAX; i++)
	{
		if (recentItem[i])
		{
			CFRelease(recentItem[i]);
			recentItem[i] = nil;
		}
	}
}

void AddRecentItem(FSRef *ref)
{
	OSStatus	err;
	char		path[PATH_MAX + 1];
	
	err = FSRefMakePath(ref, (unsigned char *) path, PATH_MAX);
	if (err == noErr)
	{
		CFStringRef	pathRef;
		
		pathRef = CFStringCreateWithCString(kCFAllocatorDefault, path, MAC_PATH_ENCODING);
		if (pathRef)
		{
			int	i, j;
			
			for (i = 0; i < kRecentMenu_MAX; i++)
				if (recentItem[i] && (CFStringCompare(pathRef, recentItem[i], 0) == 0))
					break;
					
			if (i == kRecentMenu_MAX)
			{
				for (j = kRecentMenu_MAX - 1; j >= 0; j--)
					recentItem[j + 1] = recentItem[j];
					
				if (recentItem[kRecentMenu_MAX])
				{
					CFRelease(recentItem[kRecentMenu_MAX]);
					recentItem[kRecentMenu_MAX] = nil;
				}
				
				recentItem[0] = pathRef;
			}
			else
			{
				CFRelease(pathRef);
				
				if (i > 0)
				{
					CFStringRef	temp;
					
					temp = recentItem[i];
				
					for (j = i - 1; j >=0; j--)
						recentItem[j + 1] = recentItem[j];
					
					recentItem[0] = temp;
				}
			}
		}
	}
}

static void InitRecentMenu(void)
{
	OSStatus	err;
	
	err = CreateNewMenu(mRecentItem, 0, &recentMenu);
	err = SetMenuItemHierarchicalMenu(GetMenuHandle(mFile), iOpenRecent, recentMenu);
}

static void DeinitRecentMenu(void)
{
	ReleaseMenu(recentMenu);
}

void BuildRecentMenu(void)
{
	OSStatus	err;
	CFStringRef	str;
	int			i;
	
	err = DeleteMenuItems(recentMenu, 1, CountMenuItems(recentMenu));
	
	for (i = 0; i < kRecentMenu_MAX; i++)
	{
		if (!recentItem[i])
			break;

		Boolean	r;
		char	path[PATH_MAX + 1];
		
		r = CFStringGetCString(recentItem[i], path, PATH_MAX, MAC_PATH_ENCODING);
		if (r)
		{
			CFStringRef	nameRef;
			char		drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT];
			
			_splitpath(path, drive, dir, fname, ext);
			strcat(fname, ext);
			nameRef = CFStringCreateWithCString(kCFAllocatorDefault, fname, MAC_PATH_ENCODING);
			if (nameRef)
			{
				err = AppendMenuItemTextWithCFString(recentMenu, nameRef, 0, 'FRe0' + i, nil);
				CFRelease(nameRef);
			}
		}
	}
	
	err = AppendMenuItemTextWithCFString(recentMenu, nil, kMenuItemAttrSeparator, 'FR__', nil);
	
	str = CFCopyLocalizedString(CFSTR("ClearMenu"), "ClearMenu");
	if (str)
	{
		err = AppendMenuItemTextWithCFString(recentMenu, str, 0, 'FRcr', nil);
		CFRelease(str);
	}
}

void EnableMenus(void)
{
	EnableMenuItem(GetMenuHandle(mApple),     iAbout);
	EnableMenuItem(GetMenuHandle(mFile),      0);
	EnableMenuItem(GetMenuHandle(mEmulation), 0);
	EnableMenuItem(GetMenuHandle(mControl),   0);
	EnableMenuItem(GetMenuHandle(mCheat),     0);
	EnableMenuItem(GetMenuHandle(mOption),    0);
	EnableMenuCommand(nil, kHICommandPreferences);
	EnableMenuCommand(nil, kHICommandQuit);
	
	PrepareMenus();
	DrawMenuBar();
}

void DisableMenus(void)
{
	DisableMenuItem(GetMenuHandle(mApple),     iAbout);
	DisableMenuItem(GetMenuHandle(mFile),      0);
	DisableMenuItem(GetMenuHandle(mEmulation), 0);
	DisableMenuItem(GetMenuHandle(mControl),   0);
	DisableMenuItem(GetMenuHandle(mCheat),     0);
	DisableMenuItem(GetMenuHandle(mOption),    0);
	DisableMenuCommand(nil, kHICommandPreferences);
	DisableMenuCommand(nil, kHICommandQuit);
	
	DrawMenuBar();
}

static void PrepareMenus(void)
{
	MenuHandle	fileMenu, emuMenu, ctrlMenu, cheatMenu, optionMenu;

	fileMenu   = GetMenuHandle(mFile);
	emuMenu    = GetMenuHandle(mEmulation);
	ctrlMenu   = GetMenuHandle(mControl);
	cheatMenu  = GetMenuHandle(mCheat);
	optionMenu = GetMenuHandle(mOption);

	if (cartOpen)
	{
		EnableMenuItem(fileMenu,   iRomInfo);
		EnableMenuItem(emuMenu,    iResume);
		EnableMenuItem(emuMenu,    iSoftReset);
		EnableMenuItem(emuMenu,    iReset);
		EnableMenuItem(cheatMenu,  0);
		EnableMenuItem(optionMenu, 0);
	}
	else
	{
		DisableMenuItem(fileMenu,   iRomInfo);
		DisableMenuItem(emuMenu,    iResume);
		DisableMenuItem(emuMenu,    iSoftReset);
		DisableMenuItem(emuMenu,    iReset);		
		DisableMenuItem(cheatMenu,  0);
		DisableMenuItem(optionMenu, 0);
	}
	
	if (hidExist)
	{
		EnableMenuItem(ctrlMenu, iISpLayout);
		EnableMenuItem(ctrlMenu, iISpPreset);
	}
	else
	{
		DisableMenuItem(ctrlMenu, iISpLayout);
		DisableMenuItem(ctrlMenu, iISpPreset);
	}
}

static OSStatus HandleMenuChoice(long command, Boolean *done)
{
	OSStatus	err, result = noErr;
	MenuRef		mh;
	int			item;
	
	if ((command & 0xFFFFFF00) == 'FRe\0')
	{
		Boolean	r;
		int		index;
		char	path[PATH_MAX + 1];
		
		index = (int) (command & 0x000000FF) - (int) '0';
		r = CFStringGetCString(recentItem[index], path, PATH_MAX, MAC_PATH_ENCODING);
		if (r)
		{
			FSRef	ref;
			
			err = FSPathMakeRef((unsigned char *) path, &ref, nil);
			if (err == noErr)
			{
				if (SNES9X_OpenCart(&ref))
				{
					SNES9X_Go();
					*done = true;
				}
			}
		}
	}
	else
	{
		switch (command)
		{
			case 'abou':	// About SNES9X
				StartCarbonModalDialog();
				AboutDialog();
				FinishCarbonModalDialog();
	
				break;
				
			case 'pref':	// Preferences...
				StartCarbonModalDialog();
				ConfigurePreferences();
				FinishCarbonModalDialog();
			
				break;
				
			case 'Hidn':	// (Hidden Options)			
				break;

			case 'quit':	// Quit SNES9X
				SNES9X_Quit();
				*done = true;
				
				break;
			
			case 'open':	// Open ROM Image...
				if (SNES9X_OpenCart(nil))
				{
					SNES9X_Go();
					*done = true;
				}
				
				break;
				
			case 'FRcr':	// Clear Menu
				ClearRecentItems();
				BuildRecentMenu();
				
				break;
				
			case 'Finf':	// ROM Information
				StartCarbonModalDialog();
				RomInfoDialog();
				FinishCarbonModalDialog();
					
				break;
				
			case 'Ckey':	// Configure Keyboard...
				StartCarbonModalDialog();
				ConfigureKeyboard();
				FinishCarbonModalDialog();
					
				break;
					
			case 'Cpad':	// Configure Controllers...
				StartCarbonModalDialog();	
				ConfigureHID();
				FinishCarbonModalDialog();
						
				break;
						
			case 'Caut':	// Automatic Fire...
				StartCarbonModalDialog();	
				ConfigureAutoFire();
				FinishCarbonModalDialog();
	
				break;
	
			case 'Hapl':	// Apply Cheat Entries
				mh = GetMenuHandle(mCheat);
				applycheat = !applycheat;
				CheckMenuItem(mh, iApplyCheats, applycheat);
				Settings.ApplyCheats = applycheat;
						
				if (!Settings.ApplyCheats)
					S9xRemoveCheats();
				else
					S9xApplyCheats();
	
				break;
			
			case 'Hent':	// Cheat Entry...
				StartCarbonModalDialog();	
				ConfigureCheat();
				FinishCarbonModalDialog();
						
				break;
	
			case 'Hfnd':	// Cheat Finder...
				StartCarbonModalDialog();	
				CheatFinder();
				FinishCarbonModalDialog();
						
				break;

			case 'Erun':	// Run
				SNES9X_Go();
				*done = true;
						
				break;
			
			case 'Esrs':	// Software Reset
				SNES9X_SoftReset();
				//printf("\nSoft Reset.\n\n");
				SNES9X_Go();
				*done = true;
						
				break;

			case 'Erst':	// Hardware Reset
				SNES9X_Reset();
				//printf("\nHard Reset.\n\n");
				SNES9X_Go();
				*done = true;
						
				break;
														
			case 'Eswp':	// Swap Pads
				mh = GetMenuHandle(mEmulation);
				Settings.SwapJoypads = !Settings.SwapJoypads;
				CheckMenuItem(mh, iSwapPad, Settings.SwapJoypads);

				break;
				
			case 'Essc':	// Hide or Show Gunsight Cursor
				CFStringRef	ref;
				
				scopecursor = !scopecursor;
	
				if (scopecursor)
					ref = CFCopyLocalizedString(CFSTR("HideScopeCursor"), "hide");
				else
					ref = CFCopyLocalizedString(CFSTR("ShowScopeCursor"), "show");
				mh = GetMenuHandle(mEmulation);
				err = SetMenuItemTextWithCFString(mh, iScopeCursor, ref);
				CFRelease(ref);
				
				break;
						
			case 'Ofrz':	// Freeze State
				SNES9X_Freeze();
				*done = true;
						
				break;
					
			case 'Odfr':	// Defrost state
				SNES9X_Defrost();
				*done = true;
						
				break;
						
			case 'Ofrd':	// Freeze State to...
				StartCarbonModalDialog();
				SNES9X_FreezeTo();
				FinishCarbonModalDialog();
				
				break;
			
			case 'Odfd':	// Defrost State From...
				StartCarbonModalDialog();
				SNES9X_DefrostFrom();
				if (gWindow)
					ActivateWindow(gWindow, true);
				FinishCarbonModalDialog();
				*done = true;
				
				break;
	
			case 'Ospc':	// Save SPC File at Next Note-on
				spc_is_dumping = 1;
						
				break;
						
			case 'Osrm':	// Save SRAM Now
				SNES9X_SaveSRAM();
						
				break;
				
			case 'Ombx':	// Music Box
				StartCarbonModalDialog();
				MusicBoxDialog();
				FinishCarbonModalDialog();
	
				break;
				
			case 'CPr1':	// Controller Preset
			case 'CPr2':
			case 'CPr3':
			case 'CPr4':
			case 'CPr5':		
				item = (int) (command & 0x000000FF) - (int) '0';
				err = GetMenuItemHierarchicalMenu(GetMenuHandle(mControl), iISpPreset, &mh);
				CheckMenuItem(mh, padSetting, false);
				padSetting = item;
				CheckMenuItem(mh, padSetting, true);
				ClearPadSetting();
				Load_Config();
				
				break;
				
			case 'EIp1':	// Input Device
			case 'EIp2':
			case 'EIp3':
			case 'EIp4':
			case 'EIp5':
			case 'EIp6':
			case 'EIp7':
				item = (int) (command & 0x000000FF) - (int) '0';
				err = GetMenuItemHierarchicalMenu(GetMenuHandle(mEmulation), iDevice, &mh);
				CheckMenuItem(mh, deviceSetting, false);
				deviceSetting = item;
				CheckMenuItem(mh, deviceSetting, true);
				ChangeInputDevice();
				
				break;
				
			default:
				result = eventNotHandledErr;
		}
	}
	
	return result;
}

static void ChangeInputDevice(void)
{
	switch (deviceSetting)
	{
		case iPad:
			mouseActive = false;
			Settings.ControllerOption = SNES_JOYPAD;
			Settings.Mouse = false;
			Settings.SuperScope = false;
			Settings.MultiPlayer5 = false;
			Settings.Justifier = false;
			Settings.SecondJustifier = false;
			break;
		
		case iMouse:
			mouseActive = true;
			Settings.ControllerOption = SNES_MOUSE_SWAPPED;
			Settings.Mouse = true;
			Settings.SuperScope = false;
			Settings.MultiPlayer5 = false;
			Settings.Justifier = false;
			Settings.SecondJustifier = false;
			break;
			
		case iMouse2:
			mouseActive = true;
			Settings.ControllerOption = SNES_MOUSE;
			Settings.Mouse = true;
			Settings.SuperScope = false;
			Settings.MultiPlayer5 = false;
			Settings.Justifier = false;
			Settings.SecondJustifier = false;
			break;
			
		case iSuperScope:
			mouseActive = true;
			Settings.ControllerOption = SNES_SUPERSCOPE;
			Settings.Mouse = false;
			Settings.SuperScope = true;
			Settings.MultiPlayer5 = false;
			Settings.Justifier = false;
			Settings.SecondJustifier = false;
			break;
			
		case iMultiPlayer5:
			mouseActive = false;
			Settings.ControllerOption = SNES_MULTIPLAYER5;
			Settings.Mouse = false;
			Settings.SuperScope = false;
			Settings.MultiPlayer5 = true;
			Settings.Justifier = false;
			Settings.SecondJustifier = false;
			break;
			
		case iJustifier1:
			mouseActive = true;
			Settings.ControllerOption = SNES_JUSTIFIER;
			Settings.Mouse = false;
			Settings.SuperScope = false;
			Settings.MultiPlayer5 = false;
			Settings.Justifier = true;
			Settings.SecondJustifier = false;
			break;
			
		case iJustifier2:
			mouseActive = true;
			Settings.ControllerOption = SNES_JUSTIFIER_2;
			Settings.Mouse = false;
			Settings.SuperScope = false;
			Settings.MultiPlayer5 = false;
			Settings.Justifier = false;
			Settings.SecondJustifier = true;
	}

	Settings.JustifierMaster = Settings.Justifier | Settings.SecondJustifier;
}

static Ptr SaveGWorldPixMap(GWorldPtr myWorld)
{
	PixMapHandle	GWorldPixMap;
	Ptr 			originalVideo;
	unsigned long	numRows, pixMapSize;
	bool			pixLocked;
	
	pixLocked = (GetPixelsState(GetGWorldPixMap(myWorld)) == pixelsLocked ? 1 : 0);
	
	LockPixels(GetGWorldPixMap(myWorld));
	
	GWorldPixMap = GetGWorldPixMap(myWorld);
	numRows = (*GWorldPixMap)->bounds.bottom - (*GWorldPixMap)->bounds.top;
	pixMapSize = GetPixRowBytes(GWorldPixMap) * numRows;
	originalVideo = NewPtr(pixMapSize);
	
	BlockMove(GetPixBaseAddr(GWorldPixMap), originalVideo, pixMapSize);
	
	if (!pixLocked)
		UnlockPixels(GetGWorldPixMap(myWorld));
	
	return originalVideo;
}

static void RestoreGWorldPixMap(GWorldPtr myWorld, Ptr originalVideo)
{
	PixMapHandle	GWorldPixMap;
	unsigned long	numRows, pixMapSize;
	bool			pixLocked;
	
	pixLocked = (GetPixelsState(GetGWorldPixMap(myWorld)) == pixelsLocked ? 1 : 0);
	
	LockPixels(GetGWorldPixMap(myWorld));
	
	GWorldPixMap = GetGWorldPixMap(myWorld);
	numRows = (*GWorldPixMap)->bounds.bottom - (*GWorldPixMap)->bounds.top;
	pixMapSize = GetPixRowBytes(GWorldPixMap) * numRows;
	
	BlockMove(originalVideo, GetPixBaseAddr(GWorldPixMap), pixMapSize);
		
	if (!pixLocked)
		UnlockPixels(GetGWorldPixMap(myWorld));
}

static void UpdateActiveFrame(int newIndex, GWorldPtr myWorld, Ptr originalVideo)
{
	bool	pixLocked;
				
	pixLocked = GetPixelsState(GetGWorldPixMap(myWorld)) == pixelsLocked ? 1 : 0;

	LockPixels(GetGWorldPixMap(myWorld));

	if (newIndex >= 0 && newIndex < 12)
	{
		RGBColor	yellowColor = { 0xFFFF, 0xFFFF, 0x0000 };
		Rect		drawRect    = { 118, 0, 238, 128 };
		
		OffsetRect(&drawRect, 128 * (newIndex % 4), 120 * (newIndex / 4));
		drawRect.bottom--;
		drawRect.right--;
		RGBForeColor(&yellowColor);
		FrameRect(&drawRect);
		InsetRect(&drawRect, 1, 1 );
		ForeColor(blackColor);
		FrameRect(&drawRect);
	}

	DrawFreezeDefrostScreen(myWorld);
	
	//printf("UpdateActiveFrame\n");

	RestoreGWorldPixMap(myWorld, originalVideo);

	if (!pixLocked)
		UnlockPixels(GetGWorldPixMap(myWorld));
}

int PromptFreezeDefrost(Boolean freezing)
{
	OSStatus		err;
	GWorldPtr		myWorld;
	Ptr				originalVideo;
	PicHandle		myPict;
	SndListHandle	clickSound;
	KeyMap			myKeys;
	FSCatalogInfo	info;
	FSRef			ref;
	FSSpec			spec;
	UInt64			newestDate, currentDate;
	unsigned long	startTime;
	unsigned int	repeatDelay;
	long			newestIndex;
	short			current_selection, refNum;
	int				count, result;
	const char		*filename;

	Rect 			drawRect   = { 118, 0, 238,              128 };
	Rect			worldRect  = {   0, 0, kMacWindowHeight, 512 };
	Rect			headerRect = {   0, 0, 118,              512 };
	RGBColor		darkGray   = { 0x4000, 0x4000, 0x4000 };
	char			letters[]  = "123456789ABC";
	uint8			keyCheck[] = { kmEscKey, km1Key, km2Key, km3Key, km4Key, km5Key, km6Key, km7Key, km8Key, km9Key, kmAKey, kmBKey, kmCKey };

	if (!directDisplay) 
	{
		S9xInitDisplay(nil, nil);
		SNES9X_Go();
	}
	
	frzselecting = true;

	S9xSetSoundMute(true);

	InitGWorld(&myWorld, &worldRect, Settings.SixteenBit ? 16 : 8);
	PrepareForGDrawing(myWorld);

	TextFont(kFontIDGeneva);
	TextSize(9);
	ForeColor(blackColor);
	PaintRect(&worldRect);

	myPict = GetPicture(freezing ? 129 : 130);	
	if (myPict)
	{
		DrawPicture(myPict, &headerRect);
		ReleaseResource((Handle) myPict);
	}

	newestDate  = 0;
	newestIndex = -1;

	for (count = 0; count < 12; count++)
	{
		filename = S9xGetFreezeFilename(count);
		err = FSPathMakeRef((unsigned char *) filename, &ref, nil);
		if (err == noErr)
		{
			err = FSGetCatalogInfo(&ref, kFSCatInfoContentMod, &info, nil, &spec, nil);
			currentDate = (((UInt64) info.contentModDate.highSeconds << 48) | ((UInt64) info.contentModDate.lowSeconds << 16) | (UInt64) info.contentModDate.fraction);
			
			if (currentDate > newestDate)
			{
				newestIndex = count;
				newestDate  = currentDate;
			}
			
			refNum = FSpOpenResFile(&spec, fsRdPerm);
			err = ResError();
			myPict = GetPicture(128);			
			if (myPict)
			{
				DrawPicture(myPict, &drawRect); 
				ReleaseResource((Handle) myPict);
			}
			if (err == noErr)
				CloseResFile(refNum);

			ForeColor(blackColor);
			MoveTo(drawRect.right - 1, drawRect.top);
			Line(0, 119);
			Line(-127, 0);

			MoveTo(drawRect.left + 5, drawRect.top + 15);
			TextFace(bold | outline);
			ForeColor(blackColor);
			DrawChar(letters[count]);
			MoveTo(drawRect.left + 5, drawRect.top + 15);
			TextFace(bold);
			ForeColor(whiteColor);
			DrawChar(letters[count]);
			
			if (showtimeinfrz)
			{
				LocalDateTime	localtime;
				LongDateTime	ldtime;
				Str255			p1, p2, datetimestr;

				ConvertUTCToLocalDateTime(&(info.contentModDate), &localtime);					
				ldtime = (LongDateTime) ((((UInt64) localtime.highSeconds) << 32) | ((UInt64) localtime.lowSeconds));
				LongDateString(&ldtime, shortDate, p1, nil);		
				LongTimeString(&ldtime, true, p2, nil);
				JointPStrings(p1, "\p  ", p2, datetimestr);
				
				MoveTo(drawRect.left + 22, drawRect.top + 15);
				TextFace(condense | outline);
				ForeColor(blackColor);
				DrawString(datetimestr);
				MoveTo(drawRect.left + 22, drawRect.top + 15);
				TextFace(0);
				ForeColor(whiteColor);
				DrawString(datetimestr);
			}
		}
		else
		{
			MoveTo(drawRect.left + 5, drawRect.top + 15);
			TextFace(bold);
			RGBForeColor(&darkGray);
			DrawChar(letters[count]);
		}
		
		if ((count % 4) == 3)
			OffsetRect(&drawRect, -128 * 3, 120);
		else
			OffsetRect(&drawRect, 128, 0);
	}
	
	if (newestIndex < 0)
		newestIndex = 0;
	
	originalVideo = SaveGWorldPixMap(myWorld);
	UpdateActiveFrame(newestIndex, myWorld, originalVideo);

	clickSound = (SndListHandle) GetResource('snd ', 128);
	if (clickSound)
	{
		SndPlay(nil, clickSound, false);
		ReleaseResource((Handle) clickSound);
	}
	
	result = -2;
	repeatDelay = 10;
	current_selection = (newestIndex == -1 ? 0 : newestIndex);

	do
	{
		GetKeys(myKeys);
		for (count = 0; count <= 12; count++)
		{
			while (KeyIsPressed(myKeys, keyCheck[count]))
			{
				result = count - 1;
				GetKeys(myKeys);
			}	
		}
		
		while (KeyIsPressed(myKeys, keyCode[k1PRight]))
		{
			startTime = TickCount();
			current_selection += 1;
			if (current_selection > 11)
				current_selection -= 12;
			UpdateActiveFrame(current_selection, myWorld, originalVideo);
			while (KeyIsPressed(myKeys, keyCode[k1PRight]) && (TickCount() < (startTime + repeatDelay)))
				GetKeys(myKeys);
		}

		while (KeyIsPressed(myKeys, keyCode[k1PLeft]))
		{
			startTime = TickCount();
			current_selection -= 1;
			if (current_selection < 0)
				current_selection += 12;
			UpdateActiveFrame(current_selection, myWorld, originalVideo);
			while (KeyIsPressed(myKeys, keyCode[k1PLeft]) && (TickCount() < (startTime + repeatDelay)))
				GetKeys(myKeys);
		}
		
		while (KeyIsPressed(myKeys, keyCode[k1PDown]))
		{
			startTime = TickCount();
			current_selection += 4;
			if (current_selection > 11)
				current_selection -= 12;
			UpdateActiveFrame(current_selection, myWorld, originalVideo);
			while (KeyIsPressed(myKeys, keyCode[k1PDown]) && (TickCount() < (startTime + repeatDelay)))
				GetKeys(myKeys);
		}
		
		while (KeyIsPressed(myKeys, keyCode[k1PUp]))
		{
			startTime = TickCount();
			current_selection -= 4;
			if (current_selection < 0)
				current_selection += 12;
			UpdateActiveFrame(current_selection, myWorld, originalVideo);
			while (KeyIsPressed(myKeys, keyCode[k1PUp]) && (TickCount() < (startTime + repeatDelay)))
				GetKeys(myKeys);
		}

		while (KeyIsPressed(myKeys, keyCode[k1PA]     ) ||
			   KeyIsPressed(myKeys, keyCode[k2PA]     ) ||
			   KeyIsPressed(myKeys, keyCode[k1PB]     ) ||
			   KeyIsPressed(myKeys, keyCode[k2PB]     ) ||
			   KeyIsPressed(myKeys, keyCode[k1PX]     ) ||
			   KeyIsPressed(myKeys, keyCode[k2PX]     ) ||
			   KeyIsPressed(myKeys, keyCode[k1PY]     ) ||
			   KeyIsPressed(myKeys, keyCode[k2PY]     ) ||
			   KeyIsPressed(myKeys, keyCode[k1PStart] ) ||
			   KeyIsPressed(myKeys, keyCode[k1PSelect]) ||
			   KeyIsPressed(myKeys, keyCode[k2PStart] ) ||
			   KeyIsPressed(myKeys, keyCode[k2PSelect]))
		{
			GetKeys(myKeys);
			result = current_selection;
		}
		
		uint32	pad1 = 0, pad2 = 0;
		
		while (ISpKeyIsPressed(kISpEsc    ) ||
			   ISpKeyIsPressed(kISp1PStart) ||
			   ISpKeyIsPressed(kISp2PStart))
			result = -1;
		
		pad1 = pad2 = 0;
		JoypadScanDirection(0, &pad1);
		JoypadScanDirection(1, &pad2);
		while ((pad1 & 0x0100) || (pad2 & 0x0100))	// Rt
		{
			startTime = TickCount();
			current_selection += 1;
			if (current_selection > 11)
				current_selection -= 12;
			UpdateActiveFrame(current_selection, myWorld, originalVideo);
			do
			{
				pad1 = pad2 = 0;
				JoypadScanDirection(0, &pad1);
				JoypadScanDirection(1, &pad2);
			}	
			while (((pad1 & 0x0100) || (pad2 & 0x0100)) && (TickCount() < (startTime + repeatDelay)));
		}
		
		pad1 = pad2 = 0;
		JoypadScanDirection(0, &pad1);
		JoypadScanDirection(1, &pad2);
		while ((pad1 & 0x0200) || (pad2 & 0x0200))	// Lf
		{
			startTime = TickCount();
			current_selection -= 1;
			if (current_selection < 0) 
				current_selection += 12;
			UpdateActiveFrame(current_selection, myWorld, originalVideo);
			do
			{
				pad1 = pad2 = 0;
				JoypadScanDirection(0, &pad1);
				JoypadScanDirection(1, &pad2);
			}	
			while (((pad1 & 0x0200) || (pad2 & 0x0200)) && (TickCount() < (startTime + repeatDelay)));
		}
		
		pad1 = pad2 = 0;
		JoypadScanDirection(0, &pad1);
		JoypadScanDirection(1, &pad2);
		while ((pad1 & 0x0800) || (pad2 & 0x0800))	// Up
		{
			startTime = TickCount();
			current_selection -= 4;
			if (current_selection < 0) 
				current_selection += 12;
			UpdateActiveFrame(current_selection, myWorld, originalVideo);
			do
			{
				pad1 = pad2 = 0;
				JoypadScanDirection(0, &pad1);
				JoypadScanDirection(1, &pad2);
			}	
			while (((pad1 & 0x0800) || (pad2 & 0x0800)) && (TickCount() < (startTime + repeatDelay)));
		}
			
		pad1 = pad2 = 0;
		JoypadScanDirection(0, &pad1);
		JoypadScanDirection(1, &pad2);
		while ((pad1 & 0x0400) || (pad2 & 0x0400))	// Dn
		{
			startTime = TickCount();
			current_selection += 4;
			if (current_selection > 11)
				current_selection -= 12;
			UpdateActiveFrame(current_selection, myWorld, originalVideo);
			do
			{
				pad1 = pad2 = 0;
				JoypadScanDirection(0, &pad1);
				JoypadScanDirection(1, &pad2);
			}	
			while (((pad1 & 0x0400) || (pad2 & 0x0400)) && (TickCount() < (startTime + repeatDelay)));
		}
		
		while (ISpKeyIsPressed(kISp1PA) ||
			   ISpKeyIsPressed(kISp2PA) ||
			   ISpKeyIsPressed(kISp1PB) ||
			   ISpKeyIsPressed(kISp2PB) ||
			   ISpKeyIsPressed(kISp1PX) ||
			   ISpKeyIsPressed(kISp2PX) ||
			   ISpKeyIsPressed(kISp1PY) ||
			   ISpKeyIsPressed(kISp2PY))
			result = current_selection;

		usleep(20);
		
		if (drawingMethod == kDrawingDirect)
			UpdateActiveFrame(current_selection, myWorld, originalVideo);
	}
	while (result == -2);
	
	clickSound = (SndListHandle) GetResource('snd ', 128);
	if (clickSound)
	{
		SndPlay(nil, clickSound, false);
		ReleaseResource((Handle) clickSound);
	}
	
	if (originalVideo != nil)
		DisposePtr(originalVideo);
	FinishGDrawing(myWorld);
	DisposeGWorld(myWorld);

	S9xSetSoundMute(!Settings.APUEnabled);
	
	frzselecting = false;
	
	return result;	
}

static void ProcessInput(void)
{
	static uint8	fkey[] = { kmF1Key, kmF2Key, kmF3Key, kmF4Key, kmF5Key };
	static uint8	heldFkey[5];
	
	KeyMap	myKeys;
	int		index;
	
	controlPad[0] = controlPad[1] = 0;

	if (!mouseActive && Button())
	{
		FlushEventQueue(GetCurrentEventQueue());
		running = false;
		return;
	}

	if (ISpKeyIsPressed(kISpScreenshot))
	{
		Settings.TakeScreenshot = true;
		while (ISpKeyIsPressed(kISpScreenshot));
	}
	
	if (ISpKeyIsPressed(kISpSPC))
	{
		spc_is_dumping = 1;
		while (ISpKeyIsPressed(kISpSPC));
	}

	if (ISpKeyIsPressed(kISpEsc))
	{
		if (s9xthreadrunning)
			PostQueueToSubEventLoop();
		else
			running = false;
		
		return;
	}
	
	if (ISpKeyIsPressed(kISpFreeze))
	{
		SNES9X_Freeze();
		ClearGFXScreen();
		return;
	}

	if (ISpKeyIsPressed(kISpDefrost))
	{
		SNES9X_Defrost();
		ClearGFXScreen();
		return;
	}

	JoypadScanDirection(0, &(controlPad[0]));
	if (ISpKeyIsPressed(kISp1PR     ))	controlPad[0] |= 0x0010;
	if (ISpKeyIsPressed(kISp1PL     ))	controlPad[0] |= 0x0020;
	if (ISpKeyIsPressed(kISp1PX     ))	controlPad[0] |= 0x0040;
	if (ISpKeyIsPressed(kISp1PA     ))	controlPad[0] |= 0x0080;
	if (ISpKeyIsPressed(kISp1PStart ))	controlPad[0] |= 0x1000;
	if (ISpKeyIsPressed(kISp1PSelect))	controlPad[0] |= 0x2000;
	if (ISpKeyIsPressed(kISp1PY     ))	controlPad[0] |= 0x4000;
	if (ISpKeyIsPressed(kISp1PB     ))	controlPad[0] |= 0x8000; 

	JoypadScanDirection(1, &(controlPad[1]));
	if (ISpKeyIsPressed(kISp2PR     ))	controlPad[1] |= 0x0010;
	if (ISpKeyIsPressed(kISp2PL     ))	controlPad[1] |= 0x0020;
	if (ISpKeyIsPressed(kISp2PX     ))	controlPad[1] |= 0x0040;
	if (ISpKeyIsPressed(kISp2PA     ))	controlPad[1] |= 0x0080;
	if (ISpKeyIsPressed(kISp2PStart ))	controlPad[1] |= 0x1000;
	if (ISpKeyIsPressed(kISp2PSelect))	controlPad[1] |= 0x2000;
	if (ISpKeyIsPressed(kISp2PY     ))	controlPad[1] |= 0x4000;
	if (ISpKeyIsPressed(kISp2PB     ))	controlPad[1] |= 0x8000;
		
	if (Settings.MultiPlayer5Master)
	{
		controlPad[2] = controlPad[3] = controlPad[4] = 0;

		JoypadScanDirection(2, &(controlPad[2]));
		if (ISpKeyIsPressed(kISp3PR     ))	controlPad[2] |= 0x0010;
		if (ISpKeyIsPressed(kISp3PL     ))	controlPad[2] |= 0x0020;
		if (ISpKeyIsPressed(kISp3PX     ))	controlPad[2] |= 0x0040;
		if (ISpKeyIsPressed(kISp3PA     ))	controlPad[2] |= 0x0080;
		if (ISpKeyIsPressed(kISp3PStart ))	controlPad[2] |= 0x1000;
		if (ISpKeyIsPressed(kISp3PSelect))	controlPad[2] |= 0x2000;
		if (ISpKeyIsPressed(kISp3PY     ))	controlPad[2] |= 0x4000;
		if (ISpKeyIsPressed(kISp3PB     ))	controlPad[2] |= 0x8000; 
	
		JoypadScanDirection(3, &(controlPad[3]));
		if (ISpKeyIsPressed(kISp4PR     ))	controlPad[3] |= 0x0010;
		if (ISpKeyIsPressed(kISp4PL     ))	controlPad[3] |= 0x0020;
		if (ISpKeyIsPressed(kISp4PX     ))	controlPad[3] |= 0x0040;
		if (ISpKeyIsPressed(kISp4PA     ))	controlPad[3] |= 0x0080;
		if (ISpKeyIsPressed(kISp4PStart ))	controlPad[3] |= 0x1000;
		if (ISpKeyIsPressed(kISp4PSelect))	controlPad[3] |= 0x2000;
		if (ISpKeyIsPressed(kISp4PY     ))	controlPad[3] |= 0x4000;
		if (ISpKeyIsPressed(kISp4PB     ))	controlPad[3] |= 0x8000;

		JoypadScanDirection(4, &(controlPad[4]));
		if (ISpKeyIsPressed(kISp5PR     ))	controlPad[4] |= 0x0010;
		if (ISpKeyIsPressed(kISp5PL     ))	controlPad[4] |= 0x0020;
		if (ISpKeyIsPressed(kISp5PX     ))	controlPad[4] |= 0x0040;
		if (ISpKeyIsPressed(kISp5PA     ))	controlPad[4] |= 0x0080;
		if (ISpKeyIsPressed(kISp5PStart ))	controlPad[4] |= 0x1000;
		if (ISpKeyIsPressed(kISp5PSelect))	controlPad[4] |= 0x2000;
		if (ISpKeyIsPressed(kISp5PY     ))	controlPad[4] |= 0x4000;
		if (ISpKeyIsPressed(kISp5PB     ))	controlPad[4] |= 0x8000;
	}

	GetKeys(myKeys);

	if (KeyIsPressed(myKeys, keyCode[kKeyScreenshot]))
	{
		Settings.TakeScreenshot = true;
		while (KeyIsPressed(myKeys, keyCode[kKeyScreenshot]))
			GetKeys(myKeys);
	}
	
	if (KeyIsPressed(myKeys, keyCode[kKeySPC]))
	{
		spc_is_dumping = 1;
		while (KeyIsPressed(myKeys, keyCode[kKeySPC]))
			GetKeys(myKeys);
	}
	
	if (KeyIsPressed(myKeys, kmEscKey))
	{	
		if (s9xthreadrunning)
			PostQueueToSubEventLoop();
		else
			running = false;

		return;
	}
	
	if (KeyIsPressed(myKeys, keyCode[kKeyFreeze]))
	{
		SNES9X_Freeze();
		ClearGFXScreen();
		return;
	}
		
	if (KeyIsPressed(myKeys, keyCode[kKeyDefrost]))
	{
		SNES9X_Defrost();
		ClearGFXScreen();
		return;
	}
	
	for (index = 0; index < 5; index++)
	{    
		if (KeyIsPressed(myKeys, fkey[index]))
		{
			if (KeyIsPressed(myKeys, kmCmdKey))
			{
				if (!heldFkey[index])
				{
					SNES9X_ToggleLayer(index); 
					heldFkey[index] = true;
				}
			}			
		}
		else
			heldFkey[index] = false;
	}

	if (KeyIsPressed(myKeys, keyCode[k1PR]     ))	controlPad[0] |= 0x0010;
	if (KeyIsPressed(myKeys, keyCode[k1PL]     ))	controlPad[0] |= 0x0020;
	if (KeyIsPressed(myKeys, keyCode[k1PX]     ))	controlPad[0] |= 0x0040;
	if (KeyIsPressed(myKeys, keyCode[k1PA]     ))	controlPad[0] |= 0x0080;
	if (KeyIsPressed(myKeys, keyCode[k1PRight] ))	controlPad[0] |= 0x0100;
	if (KeyIsPressed(myKeys, keyCode[k1PLeft]  ))	controlPad[0] |= 0x0200;
	if (KeyIsPressed(myKeys, keyCode[k1PDown]  ))	controlPad[0] |= 0x0400;
	if (KeyIsPressed(myKeys, keyCode[k1PUp]    ))	controlPad[0] |= 0x0800;
	if (KeyIsPressed(myKeys, keyCode[k1PStart] ))	controlPad[0] |= 0x1000;
	if (KeyIsPressed(myKeys, keyCode[k1PSelect]))	controlPad[0] |= 0x2000;
	if (KeyIsPressed(myKeys, keyCode[k1PY]     ))	controlPad[0] |= 0x4000;
	if (KeyIsPressed(myKeys, keyCode[k1PB]     ))	controlPad[0] |= 0x8000;
	
	if (KeyIsPressed(myKeys, keyCode[k2PR]     ))	controlPad[1] |= 0x0010;
	if (KeyIsPressed(myKeys, keyCode[k2PL]     ))	controlPad[1] |= 0x0020;
	if (KeyIsPressed(myKeys, keyCode[k2PX]     ))	controlPad[1] |= 0x0040;
	if (KeyIsPressed(myKeys, keyCode[k2PA]     ))	controlPad[1] |= 0x0080;
	if (KeyIsPressed(myKeys, keyCode[k2PRight] ))	controlPad[1] |= 0x0100;
	if (KeyIsPressed(myKeys, keyCode[k2PLeft]  ))	controlPad[1] |= 0x0200;
	if (KeyIsPressed(myKeys, keyCode[k2PDown]  ))	controlPad[1] |= 0x0400;
	if (KeyIsPressed(myKeys, keyCode[k2PUp]    ))	controlPad[1] |= 0x0800;
	if (KeyIsPressed(myKeys, keyCode[k2PStart] ))	controlPad[1] |= 0x1000;
	if (KeyIsPressed(myKeys, keyCode[k2PSelect]))	controlPad[1] |= 0x2000;
	if (KeyIsPressed(myKeys, keyCode[k2PY]     ))	controlPad[1] |= 0x4000;
	if (KeyIsPressed(myKeys, keyCode[k2PB]     ))	controlPad[1] |= 0x8000;
	
	if (enabletoggle)
	{
		if (KeyIsPressed(myKeys, keyCode[kKeyFastForward]) || ISpKeyIsPressed(kISpFastForward))
			toggleff = 1;
		else
		if (toggleff)
		{
			toggleff = 0;
			gFastForward = !gFastForward;
		}
	}
	else
		gFastForward = (KeyIsPressed(myKeys, keyCode[kKeyFastForward]) || ISpKeyIsPressed(kISpFastForward)) ? true : false;
	
	if (autofire)
	{
		long long	currentTime;
			
		Microseconds((UnsignedWide *) &currentTime);
		
		for (int i = 0; i < 2; i++)
		{
			if (autofireRec[i].buttonMask)
			{
				if (KeyIsPressed(myKeys, keyCode[autofireRec[i].keyboard]) || ISpKeyIsPressed(autofireRec[i].joypad))
				{
					if (currentTime > autofireRec[i].nextTime)
					{
						controlPad[i] |=  autofireRec[i].buttonMask;
						autofireRec[i].nextTime = currentTime + (long long) ((1.0 / (float) autofireRec[i].frequency) * 1000000.0);
					}
					else
						controlPad[i] &= ~autofireRec[i].buttonMask;
				}
			}
		}
	}
}

static inline void GetGameScreenRect(void)
{
	int	ph;
	
	ph = !drawoverscan ? ((IPPU.RenderedScreenHeight > 256) ? IPPU.RenderedScreenHeight : (IPPU.RenderedScreenHeight << 1)) : (SNES_HEIGHT_EXTENDED << 1);
	
	if ((drawingMethod == kDrawingOpenGL) || (drawingMethod == kDrawingBlitGL))
	{
		if (fullscreen)
		{
			if (glstretch)
			{
				if (glproportional)
				{
					scopeViewInfo.width      = (int) ((float) glScreenH / (float) ph * 512.0);
					scopeViewInfo.height     = glScreenH;
					scopeViewInfo.globalLeft = (glScreenW - scopeViewInfo.width) >> 1;
					scopeViewInfo.globalTop  = 0;
				}
				else
				{
					scopeViewInfo.width      = glScreenW;
					scopeViewInfo.height     = glScreenH;
					scopeViewInfo.globalLeft = 0;
					scopeViewInfo.globalTop  = 0;
				}
			}
			else
			{
				scopeViewInfo.width      = 512;
				scopeViewInfo.height     = ph;
				scopeViewInfo.globalLeft = (glScreenW - 512) >> 1;
				scopeViewInfo.globalTop  = (glScreenH - ph ) >> 1;
			}
		}
		else
		{
			GetWindowBounds(gWindow, kWindowContentRgn, &gWindowRect);
			
			scopeViewInfo.width      = 512;
			scopeViewInfo.height     = ph;
			scopeViewInfo.globalLeft = gWindowRect.left;
			scopeViewInfo.globalTop  = gWindowRect.top + ((kMacWindowHeight - ph) >> 1);
		}
	}
	else
	{
		if (fullscreen)
		{
			if ((IPPU.RenderedScreenWidth <= 256) && !doubleSize)
			{
				scopeViewInfo.width      = 256;
				scopeViewInfo.height     = !drawoverscan ? IPPU.RenderedScreenHeight : SNES_HEIGHT_EXTENDED;
				scopeViewInfo.globalLeft = (glScreenW - 256) >> 1;
				scopeViewInfo.globalTop  = (glScreenH - scopeViewInfo.height) >> 1;
			}
			else
			{
				scopeViewInfo.width      = 512;
				scopeViewInfo.height     = ph;
				scopeViewInfo.globalLeft = (glScreenW - 512) >> 1;
				scopeViewInfo.globalTop  = (glScreenH - ph ) >> 1;
			}
		}
		else
		{
			GetWindowBounds(gWindow, kWindowContentRgn, &gWindowRect);
			
			if ((IPPU.RenderedScreenWidth <= 256) && !doubleSize)
			{
				scopeViewInfo.width      = 256;
				scopeViewInfo.height     = !drawoverscan ? IPPU.RenderedScreenHeight : SNES_HEIGHT_EXTENDED;
				scopeViewInfo.globalLeft = gWindowRect.left + 128;
				scopeViewInfo.globalTop  = gWindowRect.top  + 120 + ((SNES_HEIGHT_EXTENDED - scopeViewInfo.height) >> 1);
			}
			else
			{
				scopeViewInfo.width      = 512;
				scopeViewInfo.height     = ph;
				scopeViewInfo.globalLeft = gWindowRect.left;
				scopeViewInfo.globalTop  = gWindowRect.top + ((kMacWindowHeight - ph) >> 1);
			}
		}
	}
}

uint32 S9xReadJoypad(int which)
{
	return (which < 5) ? (0x80000000 | controlPad[which]) : 0;
}

bool8 S9xReadSuperScopePosition(int &x, int &y, uint32 &buttons)
{
	KeyMap	keys;
	Point	pos;
	
	GetKeys(keys);
	GetGlobalMouse(&pos);
	GetGameScreenRect();

	x = (int) (((float) (pos.h - scopeViewInfo.globalLeft)) / ((float) scopeViewInfo.width ) * (float) IPPU.RenderedScreenWidth);
	y = (int) (((float) (pos.v - scopeViewInfo.globalTop )) / ((float) scopeViewInfo.height) * (float) (!drawoverscan ? IPPU.RenderedScreenHeight : SNES_HEIGHT_EXTENDED));

	//buttons = Button(); For all OS versions. One button only. 
	//buttons = GetCurrentButtonState(); OSX 10.2 or later. Supports multi-button mouse.
	if (systemVersion < 0x1020)
		buttons = Button();
	else
		buttons = ISpKeyIsPressed(kISpMouseL) ? 1 : 0;
	
	if (KeyIsPressed(keys, keyCode[kKeyScopeCursor]) || ISpKeyIsPressed(kISpScopeC))	buttons |= 2;	
	if (KeyIsPressed(keys, keyCode[kKeyScopePause] ) || ISpKeyIsPressed(kISpScopeP))	buttons |= 8;
	
	if (KeyIsPressed(keys, keyCode[kKeyScopeTurbo] ) || ISpKeyIsPressed(kISpScopeT))
		togglescopeturbo = 1;
	else
	if (togglescopeturbo)
	{
		togglescopeturbo = 0;
		gScopeTurbo = !gScopeTurbo;
	}

	buttons |= 4 * (gScopeTurbo ? 1 : 0);

	return true;
}

bool8 S9xReadMousePosition(int which1, int &x, int &y, uint32 &buttons)
{
	if (which1 == 0)
	{
		KeyMap	keys;
		Point	pos;
		
		GetKeys(keys);
		GetGlobalMouse(&pos);
		GetGameScreenRect();
		
		x = (int) (((float) (pos.h - scopeViewInfo.globalLeft)) / ((float) scopeViewInfo.width ) * (float) IPPU.RenderedScreenWidth);
		y = (int) (((float) (pos.v - scopeViewInfo.globalTop )) / ((float) scopeViewInfo.height) * (float) (!drawoverscan ? IPPU.RenderedScreenHeight : SNES_HEIGHT_EXTENDED));
					
		//buttons = Button(); For all OS versions. One button only. 
		//buttons = GetCurrentButtonState(); OSX 10.2 or later. Supports multi-button mouse.
		if (systemVersion < 0x1020)
			buttons = Button();
		else
			buttons = (ISpKeyIsPressed(kISpMouseL) ? 1 : 0) | (ISpKeyIsPressed(kISpMouseR) ? 2 : 0);
		if ((buttons == 1) && KeyIsPressed(keys, kmCtrKey))
			buttons = 2;

		return true;
	}
	
	return false;
}

bool JustifierOffscreen(void)
{
	KeyMap	keys;
	
	GetKeys(keys);
	
	return (KeyIsPressed(keys, keyCode[kKeyOffScreen]) || ISpKeyIsPressed(kISpOffScreen));
}

void JustifierButtons(uint32& justifiers)
{
	KeyMap	keys;
	
	GetKeys(keys);
	
	if (systemVersion < 0x1020)
	{
		if (IPPU.Controller == SNES_JUSTIFIER_2)	// 2P
		{
			if (Button())
			{
				if (!KeyIsPressed(keys, kmCtrKey))
					justifiers |= 0x00200;
				else
					justifiers |= 0x00800;
			}
		}
		else										// 1P
		{
			if (Button())
			{
				if (!KeyIsPressed(keys, kmCtrKey))
					justifiers |= 0x00100;
				else
					justifiers |= 0x00400;
			}
		}
	}
	else	// 10.2.x or later
	{
		if (IPPU.Controller == SNES_JUSTIFIER_2)	// 2P
		{
			if (ISpKeyIsPressed(kISpMouseL))
			{
				if (!KeyIsPressed(keys, kmCtrKey))
					justifiers |= 0x00200;
				else
					justifiers |= 0x00800;
			}
					
			if (ISpKeyIsPressed(kISpMouseR))
				justifiers |= 0x00800;
		}
		else										// 1P
		{
			if (ISpKeyIsPressed(kISpMouseL))
			{
				if (!KeyIsPressed(keys, kmCtrKey))
					justifiers |= 0x00100;
				else
					justifiers |= 0x00400;
			}
					
			if (ISpKeyIsPressed(kISpMouseR))
				justifiers |= 0x00400;
		}
	}
}

static void Initialize(void)
{
	OSStatus	err;
	CFStringRef	ref;
	IBNibRef	menuNibRef;
	MenuHandle	menu;
	int			a;
	
	printf("\nSnes9x custom %s (%s)\n\n", VERSION, MAC_VERSION);

	InitCursor();
	FlushEvents(everyEvent, 0L);
	
	err = Gestalt(gestaltSystemVersion, &systemVersion);
	
	// I don't want to use 10.1 SDK.
	
	if (systemVersion < 0x1020)
		gMainDisplayID = (CGDirectDisplayID) 0;
	else
		gMainDisplayID = CGMainDisplayID();
		
	//
	
    ZeroMemory(&Settings, sizeof(Settings));
	
    Settings.ShutdownMaster = true;
    Settings.CyclesPercentage = 100;
	Settings.SoundSkipMethod = 0;
    Settings.H_Max = SNES_CYCLES_PER_SCANLINE;
    Settings.HBlankStart = (256 * Settings.H_Max) / SNES_HCOUNTER_MAX;
    Settings.DisableIRQ = false;
	Settings.Paused = false;
	Settings.ForcedPause = false;
	Settings.StopEmulation = false;

    Settings.FrameTimePAL = 20000;
    Settings.FrameTimeNTSC = 16667;
    Settings.FrameTime = Settings.FrameTimeNTSC;
    Settings.SkipFrames = 3;

    Settings.Mouse = false;
	Settings.MouseMaster = false;
	Settings.SuperScope = false;
	Settings.SuperScopeMaster = false;
    Settings.MultiPlayer5 = false;
	Settings.MultiPlayer5Master = false;
	Settings.Justifier = false;
	Settings.SecondJustifier = false;
	Settings.JustifierMaster = false;
	Settings.ControllerOption = SNES_JOYPAD;
	
    Settings.APUEnabled = true;
    Settings.SoundPlaybackRate = 32000;
    Settings.Stereo = true;
    Settings.ReverseStereo = false;
    Settings.SixteenBitSound = true;
	Settings.SoundEnvelopeHeightReading = true;
    Settings.DisableSampleCaching = true;
	Settings.AltSampleDecode = 0;
    Settings.InterpolatedSound = true;
    Settings.NextAPUEnabled = true;
	Settings.DisableSoundEcho = false;
	Settings.DisableMasterVolume = false;
	Settings.SoundSync = false;
	Settings.SampleCatchup = false;

    Settings.SixteenBit = true;
    Settings.Transparency = true;
    Settings.SupportHiRes = true;
    Settings.Mode7Interpolate = true;

	Settings.NetPlay = false;
    Settings.ServerName[0] = 0;
	Settings.ApplyCheats = true;
	Settings.SwapJoypads = false;
	Settings.AutoSaveDelay = 0;
	Settings.TakeScreenshot = false;
	Settings.SDD1Pack = true;

	err = RegisterAppearanceClient();
	
	for (a = 0; a < kWindowCount; a++)
	{
		windowPos[a].h = 40;
		windowPos[a].v = 80;
	}
	
	InitAppleEvents();
	InitKeyboard();
	InitGraphics();
	InitAutoFire();
	InitCheatFinder();
	
   	LoadPrefs();
	
	InitMacSound();
	SetUpHID();
	
	err = CreateNibReference(CFSTR("SNES9X"), &menuNibRef);
	err = SetMenuBarFromNib(menuNibRef, CFSTR("MenuBar"));
	DisposeNibReference(menuNibRef);

	EnableMenuCommand(nil, kHICommandPreferences);
	DisableMenuItem(GetMenuHandle(mEdit), 0);
	
	if (scopecursor)
		ref = CFCopyLocalizedString(CFSTR("HideScopeCursor"), "hide");
	else
		ref = CFCopyLocalizedString(CFSTR("ShowScopeCursor"), "show");
	err = SetMenuItemTextWithCFString(GetMenuHandle(mEmulation), iScopeCursor, ref);
	CFRelease(ref);

	CheckMenuItem(GetMenuHandle(mCheat), iApplyCheats, applycheat);
	Settings.ApplyCheats = applycheat;
	
	CheckMenuItem(GetMenuHandle(mEmulation), iSwapPad, Settings.SwapJoypads);

	err = GetMenuItemHierarchicalMenu(GetMenuHandle(mControl), iISpPreset, &menu);
	CheckMenuItem(menu, padSetting, true);
	
	err = GetMenuItemHierarchicalMenu(GetMenuHandle(mEmulation), iDevice, &menu);
	CheckMenuItem(menu, deviceSetting, true);
	
	InitRecentItems();
	InitRecentMenu();
	BuildRecentMenu();
	
	DrawMenuBar();
	
	autofire = (autofireRec[0].buttonMask || autofireRec[1].buttonMask) ? true : false;
	for (a = 0; a < 5; a++)
		autofireRec[a].nextTime = 0;
	
	ChangeInputDevice();

	EnterMovies(); 
	
	if (!Memory.Init() || !S9xInitAPU() || !S9xGraphicsInit())
		QuitWithFatalError(err, "os 01");
		
	switch (mac7110Load)
	{
		case 1:
			LoadUp7110 = &SPC7110Load;
			break;
		
		case 2:
			LoadUp7110 = &SPC7110Grab;
			break;
			
		case 3:
			LoadUp7110 = &SPC7110Open;
	}
	
	cacheMegs = mac7110Megs;
	
	Settings.DisableSampleCaching = true; // force true from 1.42
	
	frzselecting = false;
}

static void Deinitialize(void)
{
	ExitMovies();
	DeinitRecentMenu();
	DeinitRecentItems();
	SavePrefs();	
	ReleaseHID();
	DeinitCheatFinder();
	DeinitGraphics();
	DeinitKeyboard();		
	DeinitMacSound();
	DeinitAppleEvents();
}

static void InitAutoFire(void)
{
	autofire = false;
	
	for (int i = 0; i < 2; i++)
	{
		autofireRec[i].nextTime   = 0;
		autofireRec[i].keyboard   = 0;
		autofireRec[i].joypad     = 0;
		autofireRec[i].buttonMask = 0;
		autofireRec[i].frequency  = 10;
	}
}

void S9xSyncSpeed(void)
{
	long long	currentFrame, adjustment;

	if (directDisplay)
	{
		Settings.SkipFrames--;
		
		if (Settings.SkipFrames <= 0)
		{
			adjustment = (gFastForward ? (1000000 / kFastForwardRate) : 1000000) / Memory.ROMFramesPerSecond;
			Microseconds((UnsignedWide *) &currentFrame);
			
			Settings.SkipFrames = ((currentFrame - lastFrame) / adjustment);
			lastFrame += frameCount * adjustment;

			if (Settings.SkipFrames < 1)
				Settings.SkipFrames = 1;
			if (Settings.SkipFrames > 7)
			{
				Settings.SkipFrames = 7;
				Microseconds((UnsignedWide *) &lastFrame);
			}

			frameCount = Settings.SkipFrames;

			while (lastFrame > currentFrame)
			{
				MPYield();
				Microseconds((UnsignedWide *) &currentFrame);
			}
			
			IPPU.RenderThisFrame = true;
		}
		else
			IPPU.RenderThisFrame = false;
	}
	else
		IPPU.RenderThisFrame = false;
}

void S9xAutoSaveSRAM(void)
{
    SNES9X_SaveSRAM();
}

void S9xMessage(int type, int number, const char *message)
{
	printf("%s\n", message);
	
	if ((type == S9X_INFO) && (number == S9X_ROM_INFO))
		if (strstr(message, "checksum ok") == nil)
			AppearanceAlert(kAlertCautionAlert, kBadRomWarning, kBadRomHint);
}

void S9xExit(void)
{
	SysBeep(1);
	
	running = false;
	cartOpen = false;

	QuitApplicationEventLoop();
}

void QuitWithFatalError(OSStatus err, const char * msg)
{
	printf("Quit. %s  err: %ld\n", msg, err);
	ExitToShell();
}
