/*******************************************************************************
  Snes9x - Portable Super Nintendo Entertainment System (TM) emulator.
 
  (c) Copyright 1996 - 2003 Gary Henderson (gary.henderson@ntlworld.com) and
                            Jerremy Koot (jkoot@snes9x.com)

  (c) Copyright 2002 - 2003 Matthew Kendora and
                            Brad Jorsch (anomie@users.sourceforge.net)
 

                      
  C4 x86 assembler and some C emulation code
  (c) Copyright 2000 - 2003 zsKnight (zsknight@zsnes.com),
                            _Demo_ (_demo_@zsnes.com), and
                            Nach (n-a-c-h@users.sourceforge.net)
                                          
  C4 C++ code
  (c) Copyright 2003 Brad Jorsch

  DSP-1 emulator code
  (c) Copyright 1998 - 2003 Ivar (ivar@snes9x.com), _Demo_, Gary Henderson,
                            John Weidman (jweidman@slip.net),
                            neviksti (neviksti@hotmail.com), and
                            Kris Bleakley (stinkfish@bigpond.com)
 
  DSP-2 emulator code
  (c) Copyright 2003 Kris Bleakley, John Weidman, neviksti, Matthew Kendora, and
                     Lord Nightmare (lord_nightmare@users.sourceforge.net

  OBC1 emulator code
  (c) Copyright 2001 - 2003 zsKnight, pagefault (pagefault@zsnes.com)
  Ported from x86 assembler to C by sanmaiwashi

  SPC7110 and RTC C++ emulator code
  (c) Copyright 2002 Matthew Kendora with research by
                     zsKnight, John Weidman, and Dark Force

  S-RTC C emulator code
  (c) Copyright 2001 John Weidman
  
  Super FX x86 assembler emulator code 
  (c) Copyright 1998 - 2003 zsKnight, _Demo_, and pagefault 

  Super FX C emulator code 
  (c) Copyright 1997 - 1999 Ivar and Gary Henderson.



 
  Specific ports contains the works of other authors. See headers in
  individual files.
 
  Snes9x homepage: http://www.snes9x.com
 
  Permission to use, copy, modify and distribute Snes9x in both binary and
  source form, for non-commercial purposes, is hereby granted without fee,
  providing that this license information and copyright notice appear with
  all copies and any derived work.
 
  This software is provided 'as-is', without any express or implied
  warranty. In no event shall the authors be held liable for any damages
  arising from the use of this software.
 
  Snes9x is freeware for PERSONAL USE only. Commercial users should
  seek permission of the copyright holders first. Commercial use includes
  charging money for Snes9x or software derived from Snes9x.
 
  The copyright holders request that bug fixes and improvements to the code
  should be forwarded to them so everyone can benefit from the modifications
  in future versions.
 
  Super NES and Super Nintendo Entertainment System are trademarks of
  Nintendo Co., Limited and its subsidiary companies.
*******************************************************************************/

/*******************************************************************************
  Snes9x custom (Snes9x for Mac OS) by zones
  
  This build was started from John Stiles' port.
*******************************************************************************/

#ifndef _mac_os_h_
#define _mac_os_h_

void InitGameWindow(void);
void DeinitGameWindow(void);
void AddRecentItem(FSRef *);
void BuildRecentMenu(void);
void EnableMenus(void);
void DisableMenus(void);
void QuitWithFatalError(OSStatus, const char *);
int PromptFreezeDefrost(Boolean);

enum
{
	kDrawingDirect = 1,
	kDrawingOpenGL,
	kDrawingBlitGL
};

enum
{
	kWindowControllers = 0,
	kWindowPreferences,
	kWindowAbout,
	kWindowAutoFire,
	kWindowMusicBox,
	kWindowRomInfo,
	kWindowCheatFinder,
	kWindowKeyConfig,
	kWindowCheatEntry,
	kWindowScreen,
	kWindowHidden,
	
	kWindowCount
};

typedef struct
{
	long long	nextTime;
	int			keyboard;
	int			joypad;
	uint16		buttonMask;
	SInt32		frequency;
}	AutoFireState;

#define	kFastForwardRate	5
#define kMacWindowHeight	478

extern volatile bool8		running;
extern uint32				controlPad[5];
extern uint8				romDetect, interleaveDetect, videoDetect, headerDetect;			
extern WindowRef			gWindow;
extern Rect					gWindowRect;
extern int					glScreenW, glScreenH;
extern Point				windowPos[kWindowCount];
extern int64				lastFrame;
extern unsigned long		spcFileCount, pngFileCount;
extern long					lastDrawingMethod;
extern Boolean				gFastForward;		
extern SInt32				systemVersion;
extern bool8				finished, cartOpen,
							autofire, hidExist, folderWarning, lockedROMMedia, directDisplay;
extern bool8				fullscreen, autoRes, doubleSize, tvMode, smoothMode, eagleMode, saiMode, supsaiMode,
							glstretch, glproportional, gl32bit, vsync, drawoverscan, multiprocessor;
extern long					drawingMethod;
extern float				macSoundPitch, macSoundPitchMaster;
extern SInt32				macSoundVolume;
extern int					macSoundInterval;
extern uint16				aueffect;
extern uint8				saveInROMFolder;
extern int					mac7110Load, mac7110Megs, macSDD1Pack;
extern bool8				startopendlog, showtimeinfrz, enabletoggle, allowevent, savewindowpos;
extern int					musicboxmode;
extern bool8				scopecursor, applycheat;
extern int					padSetting, deviceSetting;	
extern AutoFireState		autofireRec[5];
extern CGDirectDisplayID	gMainDisplayID;

#endif
